

#include <iostream>
#include <iomanip>
#include <fstream>
#include "LexicalAnalyzer.H"
#include "Parser.H"


#undef  DEBUG


using namespace v1processor;
using namespace std;


int main(int argc, char *argv[]) {
	if (argc < 3) {
		cerr << "Syntax: " << argv[0] << " source.asm destination.bin" << endl;
		return 1;
	}
	ifstream ifs(argv[1]);
	ofstream ofs(argv[2]);
	/*
	LexicalAnalyzer lex(ifs);
	while (true) {
		Token *t = lex.getNextToken();
		lex.consumeNextToken();
		cout << *t << endl;
		if (t->type == Token::TYPE_EOF)
			break;
	}
	*/
	Parser parser(ifs);
	try {
		parser.parse();
		for (vector<Instruction *>::iterator it = parser.instructions.begin(); it < parser.instructions.end(); it++) {
#ifdef  DEBUG
			cout << *(*it);
#endif
			uint16_t aux = (*it)->getBinary();
			ofs.write((char *) &aux, sizeof(uint16_t));
		}
	}
	catch (LexicalAnalyzerException &e) {
		cerr << e << endl;
		return 1;
	}
	catch (ParserException &e) {
		cerr << e << endl;
		return 1;
	}
	catch (SemanticException &e) {
		cerr << e << endl;
		return 1;
	}
	return 0;
}
